<?php

define('MOD_COUNTER_OPTIONS_STORAGE','opts');

class CounterOptions
{
	
	var	$stylePath_
	,	$numberDigits_;
	
	function CounterOptions($file=MOD_COUNTER_OPTIONS_STORAGE,$stylePathFull=false,$style=null)
	{
		
		if(!file_exists($file)&&(isset($_GET['source'])||$style!==null))
		{
			if($style===null)
				$style=$_GET['source'];
			if($f=fopen($file,'w'))
			{
				fwrite($f,$GLOBALS['SITE_BUILDER']['MODULES_PATH']."counter/styles/$style\n5");
				fclose($f);
			}
			else
			{
				$mes='CounterOptions::CounterOptions -> File write fail!';
				error_log($mes);
				echo "<h1>$mes</h1>";
				exit(1);
			}
		}
		
		$data=file($file);
		if(is_array($data)&&sizeof($data)==2)
		{
			$this->stylePath_=($stylePathFull
				?	trim($data[0])
				:	dirname(__FILE__).'/'.trim($data[0]))
			.'/';
			$this->numberDigits_=trim($data[1]);
		}
		else
			$this->stylePath_=$this->numberDigits_='';

		
	}
	
	function GetDigNum()
	{
		return $this->numberDigits_;
	}
	
	function GetStylePath()
	{
		return $this->stylePath_;
	}
	
}

class CounterImage
{
	
	var	$error_=null
	,	$output_
	,	$options_
	,	$value_
	,	$lenght_=0
	,	$images_=array()
	,	$test_=false
	,	$height_=0
	,	$width_=0;
	
	function CounterImage($value,$options='',$test=false)
	{
		
		$this->test_=$test;
		
		$this->options_=empty($options)
			?	new CounterOptions()
			:	$options;
			
		if(		!function_exists('getimagesize')
			||	!function_exists('imagecreate')
			||	!function_exists('imagecopymerge')
			||	!function_exists('imagecreatefromjpeg')
			||	!function_exists('imagejpeg'))
		{
			$this->error_='gd_error';
			return;
		}
		
		$this->value_=strval($value);
		
		$this->CreateOutput();
		
	}
	
	function CreateOutput()
	{

		$this->CheckLenght();
		
		if(!$this->test_)
			$this->LoadImages();

		list($this->width_,$this->height_)=getimagesize($this->options_->GetStylePath().'0.jpg');
		
		if(!$this->test_)
			$this->output_=imagecreate($this->width_*$this->lenght_,$this->height_);
			
		if(!$this->test_)
		{
			$i=0;
			foreach($this->images_ as $img)
				imageCopyMerge($this->output_,$img,0+$this->width_*$i++,0,0,0,$this->width_,$this->height_,100);
		}

	}
	
	function LoadImages()
	{
		
		$ds=preg_split('//',$this->value_,-1,PREG_SPLIT_NO_EMPTY);
		$path=$this->options_->GetStylePath();
		
		foreach($ds as $d) {
			array_push($this->images_,imagecreatefromjpeg("$path$d.jpg"));
		}	
		
	}

	function CheckLenght()
	{
		
		$this->lenght_=$this->options_->GetDigNum();
		$c=strlen($this->value_);
		
		if($c<$this->lenght_)
		{
			$z='';
			for($i=$c;$i<$this->lenght_;++$i)
				$z.='0';
			$this->value_=$z.$this->value_;
		}
		elseif($c>$this->lenght_)
			$this->lenght_=$c;

	}
	
	
	function Show()
	{
		
		Header("Expires: Wen, 04 Jul 1980 06:15:00 GMT"); 
		
		if($this->error_===null)
			imagejpeg($this->output_);
		else
		{
			header('Content-type: image/gif');
			readfile($this->options_->GetStylePath().'../'.$this->error_.'.gif');
		}
		
	}
	
	function GetHeight()
	{
		return $this->height_;
	}
	function GetWidth()
	{
		return $this->width_*$this->lenght_;
	}

	
}

?>